public class List {
   Element root;
   
   public boolean equals(Object other) {
      if (other instanceof List) {
         Element one = this.root;
         Element two = ((List)other).root;
         while (one != null && two != null) {
            if (one.x != two.x) {
               return false;
            }
            one = one.next;
            two = two.next;
         }
         return (one == null && two == null);
      } else {
         return false;
      }
   }
}


class Element {
   int x;
   Element next;
   
   Element(int x, Element next) {
      this.x = x;
      this.next = next;
   }
}
